#coding=utf-8

"""
@project : checkCephFile
@author  : wenjian
#@time   : 2022-03-10 14:07:50
"""

# 功能点
# 1. 传入ceph信息
# 2. 指定含日期的路径，检测success.ok文件是否存在
# 3. 逻辑操作

import sys
import os    
import time
import datetime
from pathlib import Path
from boto3.session import Session

if __name__ == '__main__':
    yesterday = (datetime.date.today() + datetime.timedelta(days=-1)).strftime("%Y%m%d")
    today = (datetime.date.today()).strftime("%Y%m%d")
    parameter_length = len(sys.argv[1:])
    if  parameter_length != 1:
        sys.exit("parameter length must be 1")
    args = sys.argv[1:]
    print(args)
    parameter_dict = eval(args[0])

    # 获取文件参数，扫描是否含有指定日期dt参数，用于后续指定日期检测，如果没有则默认为昨天
    if parameter_dict.__contains__("dt"):
        formatted_date = parameter_dict["dt"]
    else:
        formatted_date = (datetime.date.today() + datetime.timedelta(days=-1)).strftime("%Y%m%d")

    # 获取ceph信息
    access_key = parameter_dict["access_key"]
    secret_key = parameter_dict["secret_key"]
    url = parameter_dict["url"]
    bucket_name = parameter_dict["bucket_name"]
    # 拼接ceph路径
    ceph_file_path = (parameter_dict["ceph_file_path"][:len(parameter_dict["ceph_file_path"])-1] if parameter_dict["ceph_file_path"].endswith("/") else parameter_dict["ceph_file_path"]) + "/" + formatted_date

    # 连接ceph
    session = Session(access_key, secret_key)
    s3_client = session.client('s3', endpoint_url=url)
    resp = s3_client.list_objects(Bucket=bucket_name,Prefix=ceph_file_path)

    # 判断是否含有success.ok文件
    flag = 0
    try:
        for obj in resp['Contents']:
            if ceph_file_path in obj['Key'] and obj['Key'].__contains__("success.ok"):
                print("the content file path is :"+obj['Key'])
                flag = 1
                with open('C:/WKFS/paopi/logs/%s-flag.log'%today,'w') as f:
                    f.write(str(flag))
                break
            else:
                with open('C:/WKFS/paopi/logs/%s-flag.log'%today,'w') as f:
                    f.write(str(flag))
                print("the ceph path doesn't contain success.ok file")
    except:
        with open('C:/WKFS/paopi/logs/%s-flag.log'%today,'w') as f:
            f.write(str(flag))
        print("the ceph path doesn't contain success.ok file")
    
    
    def sys_version(ipaddress):
        conn = wmi.WMI(computer=ipaddress)
        for sys in conn.Win32_OperatingSystem():
            print("Version:%s" % sys.Caption.encode("UTF8"),"Vernum:%s" % sys.BuildNumber)  #系统信息
            print(sys.OSArchitecture.encode("UTF8") ) # 系统的位数
            print(sys.NumberOfProcesses)  # 系统的进程数
        try:
            filename1 = "cd C:\WKFS\ETL\ && .\INTEGRATED_RUN_SGA.bat %s" %yesterday
            filename2 = "cd C:\WKFS\ETL\ && .\INTEGRATED_RUN_SGMAS.bat %s" %yesterday
            
            res1 = conn.Win32_Process.Create(CommandLine=filename1)  #执行bat文件   Win32_Process.Create
            res2 = conn.Win32_Process.Create(CommandLine=filename2)
            
            print(res1)
            print(res2)
            
        except Exception as e:
            print(e)
    # 针对文件的逻辑操作
    #run_auto_script = 0
    filename1 = "cd C:\WKFS\ETL && INTEGRATED_RUN_SGA.bat %s" %yesterday
    filename2 = "cd C:\WKFS\ETL && INTEGRATED_RUN_SGMAS.bat %s" %yesterday
    
    
    with open('C:/WKFS/paopi/RUN_SGA.bat','w') as f:
        f.write(filename1)
    with open('C:/WKFS/paopi/RUN_SGMAS.bat','w') as f:
        f.write(filename2)
    log_path = 'C:/WKFS/paopi/logs/%s.log'%yesterday
    run_auto_script_file = Path(log_path)
    if run_auto_script_file.exists():    
        with open(log_path,'r+') as f:
            res_read = f.readline()
            print(res_read)
            if res_read and int(res_read) != 0:
                res_read = int(res_read)
                #print(run_auto_script)
                
                #f.write(str(int(res_read) + 1))
                
                print("has auto runed. exit ")
                exit()
            else:
                res_read = 0
                run_auto_script = res_read
    else:
        run_auto_script = 0
        #with open(log_path,'w') as f:
        #    f.write(str(run_auto_script))
        
        print(run_auto_script)
    
    if flag == 1 and run_auto_script == 0 :
        print("The check task is successfully executed, and will continue to execute the next batch of tasks")

        print("start to auto run -----")
        filename1 = "C:\WKFS\ETL\INTEGRATED_RUN_SGA.bat %s" %yesterday
        filename2 = "C:\WKFS\ETL\INTEGRATED_RUN_SGMAS.bat %s" %yesterday
        


    else:
        #print('test-')
        #sys_version(ipaddress="127.0.0.1")
        print("The task has not been executed, please be patient")



#uat： python check_ceph_success.py "{'access_key':'NVJQGD1NZE650T3UVIT4','secret_key':'SzCDCPAcUaSAOU08ToEqVGKXIVAgMLGpKYbnB8D7','bucket_name':'core-banking-dwh-uat1','url':'http://corebank-ceph-uat1.mdw.maribanksvc.com','ceph_file_path':'/dw/out/wk/'}"


#uat： python check_ceph_success.py "{'access_key':'NVJQGD1NZE650T3UVIT4','secret_key':'SzCDCPAcUaSAOU08ToEqVGKXIVAgMLGpKYbnB8D7','bucket_name':'core-banking-dwh-uat1','url':'http://10.165.54.128:7480','ceph_file_path':'/dw/out/wk/'}"


#staging： python check_ceph_success.py "{'access_key':'NVJQGD1NZE650T3UVIT4','secret_key':'SzCDCPAcUaSAOU08ToEqVGKXIVAgMLGpKYbnB8D7','bucket_name':'core-banking-dwh-staging','url':'http://corebank-ceph-staging.mdw.maribanksvc.com','ceph_file_path':'/dw/out/wk/'}"

