
#!/usr/bin/python3
# yule.wen 2021/8/12
# -*- coding: utf-8 -*-
# use func: id live 一键创建，授权脚本


import json
import datetime
import sys
import os
import subprocess

help_str = """
-c create single bucket
-o the bucket owner,this arg is must need
-f create bucket from file
-b build auth policy
-u user, auth the bucket to the user
-p policy eg: read/write/all

1.create single bucket
python3 ceph-create.py -c bucket_name -o bke_log

2.create bucket from bucket_file
python3 ceph-create.py -f bucket_file_name -o bke_log

3.auth bucket to user
python3 ceph-create.py -b bucket_name -o bke_log -u bke_core -p [read|write|all]




"""
ak_sk = {
    "bke_mobile": {
        "access_key": "BP9ATFIFSU3PJF67J5LJ",
        "secret_key": "Qjf0TxhaBSXa23fRAJy0wzqRSUdbUQ9mYouqKi5G"
    },
    "bke_core": {
        "access_key": "4CZXJW7T8CCS7GJ958PJ",
        "secret_key": "ytDBeP4pptCCUXBIN3IKe93BT7bSDZFBl4Roi5Ix"
    },
    "bke_dwh": {
        "access_key": "JZSG0196V86LBPGMPG6C",
        "secret_key": "OGYfynlMjYCKef3RV10YOnaZPErqYy2e78DutqKp"
    },
    "banking_toc": {
        "access_key": "OEYQA8XI83J2ASBGC51D",
        "secret_key": "JpJO8oYKyibR9JhWz8APpxXHKhFRIe3HMNmto9oA"
    },
    "bke_video": {
        "access_key": "N6MVUH4KXJLFVI2FEIM1",
        "secret_key": "5nOy7mIAaEx5hLwNVQ5AHfrtB0Us0LbFm35jI7Za"
    },
    "bke_ds": {
        "access_key": "BVBI9FSNQQESRTA37CEL",
        "secret_key": "xsBpssr3JDzCfAgFr6c9lDvav7TAYsh0WNOvWkNp"
    },
    "bke_xlog": {
        "access_key": "5QV63AHYGZ05F52050AP",
        "secret_key": "MJRByPc7hkLTYj6wjUvKR65YsbgpaONEsc5EpHuh"
    },
    "tracker": {
        "access_key": "RRA0H18ZG4WD4WL0TWM6",
        "secret_key": "aBzwPf7fAmxKSQGpjhloJKDO1aj3YXbq1E1M5WAL"
    },
    "bke_loan": {
        "access_key": "P9RBP43P0D5JF79SD59T",
        "secret_key": "VZT2ChLxqtIvBHLvAsPWoenGQa7q26t6JqpFUm66"
    },
    "vk": {
        "access_key": "2UWWV9A6BE1CKD7S03EC",
        "secret_key": "YWzmSX0KHDocxjqUEd15R0AYdUtUAdcwsJxomMeG"
    },
    "banking_core_live": {
        "access_key": "LTAAV24PDGB4E98BZKS9",
        "secret_key": "x5qw6kpk9rNJoG0XV8bLTBINxEHAhwcZM21wJXki"
    },
    "zoneuser": {
        "access_key": "SI5OMSH2ASIF31BK532F",
        "secret_key": "fLCb4dfAZ2V8Fb6CRJieuUgnhzGFqlrWKvqvaPlF"
    },
    "devops": {
        "access_key": "02K628XXACYMF08C3N81",
        "secret_key": "WTTNpkfGNOZQd4X5irgqjlcwNnX6NYnXajjmoBRn"
    }

}


def print_green(s):
    print('\033[0;32;40m %s \033[0m' % s)


def print_red(s):
    print('\033[0;31;40m %s \033[0m' % s)


def exec_func(exec_str):
    res = subprocess.Popen(exec_str, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    print(str(res.stdout.read(), encoding='utf-8'))


def build_police(bucket, owner, user, policy):
    date_obj = datetime.datetime.now()
    date_str = "%s-%s-%s_%s%s%s" % (
        date_obj.year, date_obj.month, date_obj.day, date_obj.hour, date_obj.month, date_obj.second)

    bucket = bucket.strip('')
    owner = owner.strip('')
    user = user.strip('')
    policy = policy.strip()
    if owner not in ak_sk:
        print_red('the owner is error')
        exit(1)
    ak_key = ak_sk.get(owner).get("access_key")
    sk_key = ak_sk.get(owner).get("secret_key")

    def police_template(auth_user, auth_action, auth_bucket):
        return {
            "Sid": auth_user,
            "Effect": "Allow",
            "Principal": {"AWS": "arn:aws:iam:::user/" + auth_user},
            "Action": auth_action,
            "Resource": [
                "arn:aws:s3:::" + auth_bucket + "/*",
                "arn:aws:s3:::" + auth_bucket,
            ]
        }

    statements = []

    def auth_temp(auth_policy):
        if auth_policy == "read":
            statements.append(police_template(user, "s3:GetObject*", bucket))
            statements.append(police_template(user, "s3:ListBucket*", bucket))
        elif auth_policy == "write":
            statements.append(police_template(user, "s3:DeleteObject*", bucket))
            statements.append(police_template(user, "s3:PutObject*", bucket))
        elif auth_policy == "all":
            statements.append(police_template(user, "s3:*", bucket))
        else:
            print_red("auth error")
            exit(1)
        return {"Version": "2012-10-17", "Statement": statements}

    police = auth_temp(policy)
    from pathlib import Path
    dir = Path('./policy_record')
    if not dir.exists():
        os.mkdir('policy_record')
    police_save_filename = "./policy_record/%s_policy_%s.json" % (bucket, date_str)
    with open(police_save_filename, 'a+') as f:
        f.write(json.dumps(police))
        exec_str = "s3cmd --no-ssl --access_key=%s --secret_key=%s --host-bucket= --host=127.0.0.1:7480 setpolicy %s s3://%s" % (ak_key, sk_key, police_save_filename, bucket)
    print(exec_str)
    res = subprocess.Popen(exec_str, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    print(str(res.stdout.read(), encoding='utf-8'))


def create_bucket(create_bucket_name, bucket_owner):
    create_bucket_name = create_bucket_name.strip('')
    bucket_owner = bucket_owner.strip('')
    if bucket_owner not in ak_sk:
        print_red('the owner is error')
        exit(1)
    ak = ak_sk.get(bucket_owner).get("access_key")
    sk = ak_sk.get(bucket_owner).get("secret_key")

    exec_str = 's3cmd --no-ssl --access_key=%s --secret_key=%s --host-bucket= ' \
               '--host=127.0.0.1:7480 mb s3://%s' % (ak, sk, create_bucket_name)
    print(exec_str)
    res = subprocess.Popen(exec_str, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    print(str(res.stdout.read(), encoding='utf-8'))


args_list = sys.argv
args_lens = len(args_list)

action = ''
name = ''
# print(args_list, args_lens)


if args_lens == 5 or args_lens == 9:
    action = args_list[1]
    if action == '-c':
        bucket_name = args_list[2]
        owner = args_list[4]
        create_bucket(bucket_name, owner)
    elif action == '-f':
        bucket_file_name = args_list[2]
        owner = args_list[4]
        print(bucket_file_name, owner)
        with open('./%s' % bucket_file_name, 'r') as f:
            bucket_name_list = f.readlines()
        for i in bucket_name_list:
            create_bucket(i, owner)

    elif action == '-b':
        bucket_name = args_list[2]
        owner = args_list[4]
        user = args_list[6]
        policy = args_list[8]
        build_police(bucket_name, owner, user, policy)
    else:
        print_red('plz input correct')
        print_green(help_str)
else:
    print_red("plz input correct!")
    print_green(help_str)
    exit(1)
