#!/bin/bash
mtr_result=/opt/cert_monitor/mtr_result.prome
mtr_exporter=/opt/cert_monitor/mtr_result.prom
time=$(date +%F_%H-%M-%S)

# spm im vip 443
mtr_vip_443() {
    dst=143.92.90.115
    port=443
    dst_role="mtr-${dst}-${port}"
    res_name="${dst_role}"
    res_mtr=$(mtr --tcp --port ${port} ${dst} -r|awk 'END{print $3}'|awk -F '.' '{print$1}')
    echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"${dst}\",server=\"$(hostname)\",dst_role=\"${dst_role}\"} ${res_mtr}" >> ${res_name}.prome
    mv ${res_name}.prome  ${res_name}.prom
}


mtr_vip_80() {
    dst=143.92.90.115
    port=80
    dst_role="mtr-${dst}-${port}"
    res_name="${dst_role}"
    res_mtr=$(mtr --tcp --port ${port} ${dst} -r|awk 'END{print $3}'|awk -F '.' '{print$1}')         
    echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"${dst}\",server=\"$(hostname)\",dst_role=\"${dst_role}\"} ${res_mtr}" >> ${res_name}.prome
    mv ${res_name}.prome  ${res_name}.prom
}

mtr_vip_ping() {
    dst=143.92.90.115
    dst_role="mtr-${dst}-${port}"
    res_name="${dst_role}"
    res_mtr=$(mtr --tcp  ${dst} -r|awk 'END{print $3}'|awk -F '.' '{print$1}')
    echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"${dst}\",server=\"$(hostname)\",dst_role=\"${dst_role}\"} ${res_mtr}" >> ${res_name}.prome
    mv ${res_name}.prome  ${res_name}.prom
}

mtr_real_443() {
    dst=143.92.90.97
    port=443
    dst_role="mtr-${dst}-${port}"
    res_name="${dst_role}"
    res_mtr=$(mtr --tcp --port ${port} ${dst} -r|awk 'END{print $3}'|awk -F '.' '{print$1}')
    echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"${dst}\",server=\"$(hostname)\",dst_role=\"${dst_role}\"} ${res_mtr}" >> ${res_name}.prome
    mv ${res_name}.prome  ${res_name}.prom
}

main(){
    mtr_vip_443
    mtr_vip_80
    mtr_vip_ping
    mtr_real_443
}

main







# spm im vip 443
mtr_vip_80() {
    mtr_vip_80=$(mtr --tcp --port 443 spm-bank.wallet.airpay.com.ph -r|awk 'END{print $3}'|awk -F '.' '{print$1}')
    echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"143.92.90.115\",server=\"$(hostname)\",dst_role=\"mtr_vip_443\"} ${mtr_vip_80}" >> mtr_vip_443.prome
    mv mtr_vip_443.prome  mtr_vip_443.prom
}



# spm im 80
mtr_vip(){
    mtr_ret_spm_80=$(mtr --tcp --port 80 spm-bank.wallet.airpay.com.ph -r |awk 'END{print $3}'|awk -F '.' '{print$1}')
    
}
# credit 443
mtr_ret1=$(mtr --tcp --port 443 192.168.163.58 -r |grep 192.168.163.58 |awk '{print $3}'|awk -F '.' '{print$1}')
mtr_ret2=$(mtr --tcp --port 443 192.168.163.115 -r |grep 192.168.163.115 |awk '{print $3}'|awk -F '.' '{print$1}')

# spm tellin
mtr_ret3=$(mtr --tcp --port 443 143.92.65.81 -r |grep 143.92.65.81 |awk '{print $3}'|awk -F '.' '{print$1}')
mtr_ret4=$(mtr --tcp --port 443 143.92.65.82 -r |grep 143.92.65.82 |awk '{print $3}'|awk -F '.' '{print$1}')

# spm im real ip
mtr_ret_spm_443_rp1=$(mtr --tcp --port 443 143.92.90.97 -r |grep 143.92.90.97 |awk '{print $3}'|awk -F '.' '{print$1}')
mtr_ret_spm_443_rp2=$(mtr --tcp --port 443 143.92.90.98 -r |grep 143.92.90.98 |awk '{print $3}'|awk -F '.' '{print$1}')


echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"spm-bank.wallet.airpay.com.ph\",server=\"$(hostname)\",dst_role=\"spm im 80\"} ${mtr_ret_spm_80}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"192.168.163.58\",server=\"$(hostname)\",dst_role=\"credit\"} ${mtr_ret1}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"192.168.163.115\",server=\"$(hostname)\",dst_role=\"credit\"} ${mtr_ret2}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"143.92.65.81\",server=\"$(hostname)\",dst_role=\"spm tellin\"} ${mtr_ret3}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"143.92.90.97\",server=\"$(hostname)\",dst_role=\"spm im real ip\"} ${mtr_ret_spm_443_rp1}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"143.92.90.98\",server=\"$(hostname)\",dst_role=\"spm im real ip\"} ${mtr_ret_spm_443_rp2}" >> $mtr_result && \
#echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"143.92.65.82\",server=\"$(hostname)\",dst_role=\"spm tellin\"} ${mtr_ret4}" >> $mtr_result && \
mv ${mtr_result} ${mtr_exporter}