#!/bin/bash
mtr_result=/opt/cert_monitor/mtr_result.prome
mtr_exporter=/opt/cert_monitor/mtr_result.prom
time=$(date +%F_%H-%M-%S)

# spm im 443
mtr_ret_spm_443=$(mtr --tcp --port 443 spm-bank.wallet.airpay.com.ph -r |grep 143.92.90.115 |awk '{print $3}'|awk -F '.' '{print$1}')

# spm im 80
mtr_ret_spm_80=$(mtr --tcp --port 80 spm-bank.wallet.airpay.com.ph -r |grep 143.92.90.115 |awk '{print $3}'|awk -F '.' '{print$1}')

# credit 443
mtr_ret1=$(mtr --tcp --port 443 192.168.163.58 -r |grep 192.168.163.58 |awk '{print $3}'|awk -F '.' '{print$1}')
mtr_ret2=$(mtr --tcp --port 443 192.168.163.115 -r |grep 192.168.163.115 |awk '{print $3}'|awk -F '.' '{print$1}')

# spm tellin
mtr_ret3=$(mtr --tcp --port 443 143.92.65.81 -r |grep 143.92.65.81 |awk '{print $3}'|awk -F '.' '{print$1}')
mtr_ret4=$(mtr --tcp --port 443 143.92.65.82 -r |grep 143.92.65.82 |awk '{print $3}'|awk -F '.' '{print$1}')

# spm im real ip 
mtr_ret_spm_443_rp1=$(mtr --tcp --port 443 143.92.90.97 -r |grep 143.92.90.97 |awk '{print $3}'|awk -F '.' '{print$1}')
mtr_ret_spm_443_rp2=$(mtr --tcp --port 443 143.92.90.98 -r |grep 143.92.90.98 |awk '{print $3}'|awk -F '.' '{print$1}')

echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"spm-bank.wallet.airpay.com.ph\",server=\"$(hostname)\",dst_role=\"spm im 443\"} ${mtr_ret_spm_443}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"spm-bank.wallet.airpay.com.ph\",server=\"$(hostname)\",dst_role=\"spm im 80\"} ${mtr_ret_spm_80}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"192.168.163.58\",server=\"$(hostname)\",dst_role=\"credit\"} ${mtr_ret1}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"192.168.163.115\",server=\"$(hostname)\",dst_role=\"credit\"} ${mtr_ret2}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"143.92.65.81\",server=\"$(hostname)\",dst_role=\"spm tellin\"} ${mtr_ret3}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"143.92.90.97\",server=\"$(hostname)\",dst_role=\"spm im real ip\"} ${mtr_ret_spm_443_rp1}" >> $mtr_result && \
echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"143.92.90.98\",server=\"$(hostname)\",dst_role=\"spm im real ip\"} ${mtr_ret_spm_443_rp2}" >> $mtr_result && \
#echo "mtr_tcp_port_packet_lost_percent{dst_domain=\"143.92.65.82\",server=\"$(hostname)\",dst_role=\"spm tellin\"} ${mtr_ret4}" >> $mtr_result && \
mv ${mtr_result} ${mtr_exporter}