# -*- coding: utf-8 -*-
# !/usr/bin/env python3
# yule.wen 2021/5/20-5:04 下午
# use func: 拉取Apollo的手机银行配置


import datetime
import time
import openpyxl
import requests
from openpyxl.styles import Alignment
from openpyxl.utils import get_column_letter
from settings.config import *



s_time = time.time()
headers = {
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) '
                  'Chrome/72.0.3626.121 Safari/537.36',
    'Authorization': '',
    'Content-Type': 'application/json;charset=UTF-8'
}


def get_all_appid(url, token):
    url = url + '/openapi/v1/apps?appIds'

    print(url)
    headers["Authorization"] = token
    res_list = requests.get(headers=headers, url=url).json()
    # print(type(res_list),res_list)
    appid_list = []
    for item_dc in res_list:
        # print(item_dc)
        appid_list.append(item_dc["appId"])
    # print(appid_list)
    return appid_list


def get_all_props(url, token, appid, envs, clusters="default"):
    url = url + f'/openapi/v1/envs/{envs}/apps/{appid}/clusters/{clusters}/namespaces'
    headers["Authorization"] = token
    props = requests.get(headers=headers, url=url).json()
    # with open('js.json', 'a') as f:
    #     f.write(str(props))
        # f.write(json.dumps(props[0], indent=2, ensure_ascii=False))
        # f.write(json.dumps(props[1], indent=2, ensure_ascii=False))
    # print()
    # if envs=='dr':
    #     print("props-----",props)
    # return {
    #     "appId": props["appId"],
    #     "items": props["items"]
    # }

    # appId = props["appId"]
    app_props_dict = {}
    # print(props)
    for ns_props in props:
        app_props_dict[ns_props["namespaceName"]] = {}
        # print(app_props_dict)
        for single_props in ns_props["items"]:
            if single_props["key"] == "":
                continue
            app_props_dict[ns_props["namespaceName"]][single_props["key"]] = single_props["value"]
        # app_props_dict.append(s_dict)
    # print("app_props_dict----->", app_props_dict)
    return app_props_dict


# 获取live的所有appid和配置



allApp = get_all_appid(url_app_live, token_app_live)



def get_live_props():
    live_props = {}
    for app in allApp:
        app_props = get_all_props(url_app_live, token_app_live, app, envs="LIVE")
        live_props[app] = app_props
    return live_props


def get_dr_props():
    dr_props = {}

    for app in allApp:
        # print("dr app",app)
        app_props = get_all_props(url_app_dr, token_app_dr, app, envs="DR")
        # print('app_props===========',app_props)
        dr_props[app] = app_props
    return dr_props
import json
res1 = get_live_props()
# print('-----res2',res1)
with open('./get_apollo_config.json','w',encoding='utf-8') as f:
    f.write(json.dumps(res1))


res2 = get_dr_props()

# print('-----res2',res2)

workbook = openpyxl.Workbook()

for app in allApp:
    worksheet = workbook.create_sheet(app)
    worksheet.cell(row=1, column=1).value = 'key'

    worksheet.cell(row=1, column=2).value = 'value_live'  # write(0, 1, 'value_live')
    worksheet.cell(row=1, column=3).value = 'value_dr'  # write(0, 2, 'value_dr')
    worksheet.cell(row=1, column=4).value = 'namespace'
    worksheet.column_dimensions[get_column_letter(1)].width = 30
    worksheet.column_dimensions[get_column_letter(2)].width = 50
    worksheet.column_dimensions[get_column_letter(3)].width = 50
    worksheet.column_dimensions[get_column_letter(4)].width = 50
    all_ns_differ_props = {}
    for ns_key in res1[app]:
        ns_differ_props = set(res1[app][ns_key].items()) #^ set(res2[app][ns_key].items())
    # print(differ_props)
        ns_differ_props_list = list(ns_differ_props)
        ns_differ_props_list.sort()
        all_ns_differ_props[ns_key]=ns_differ_props_list
    # print(app, differ_props_list)
    # if differ_props:
    #     differ_dict[app] = list(differ_props)
    # print(differ_dict)

    for ns_diff_key,ns_diff_val_list in all_ns_differ_props.items():
        # print('differ_props_list[i][0]', differ_props_list[i][0])
        # if ns_diff_key == all_ns_differ_props[0]
        # cur_row_num = 0
        # for row_index in worksheet.rows: cur_row_num += 1
        row_num = worksheet.max_row
        for i in range(len(ns_diff_val_list)):
            # for row_index in worksheet.rows: cur_row_num += 1

            if ns_diff_val_list[i][0] == ns_diff_val_list[i - 1][0] and i > 0:
                if ns_diff_val_list[i][1] == res1[app][ns_diff_key].get(ns_diff_val_list[i][0]):
                    worksheet.cell(row=i + 1+row_num, column=2, value=ns_diff_val_list[i][1]).alignment = Alignment(wrapText=True)
                elif ns_diff_val_list[i][1] == res2[app][ns_diff_key].get(ns_diff_val_list[i][0]):
                    worksheet.cell(row=i + 1+row_num, column=3, value=ns_diff_val_list[i][1]).alignment = Alignment(wrapText=True)
            else:
                # worksheet.cell
                # worksheet.cell(row=i + 1 + row_num, column=1, value=ns_diff_key).alignment = Alignment(wrapText=True)
                worksheet.cell(row=i + 2 + row_num, column=1, value=ns_diff_val_list[i][0]).alignment = Alignment(wrapText=True)
                worksheet.cell(row=i + 2 + row_num, column=4, value=ns_diff_key).alignment = Alignment(wrapText=True)
                if ns_diff_val_list[i][1] == res1[app][ns_diff_key].get(ns_diff_val_list[i][0]):
                    worksheet.cell(row=i + 2+row_num, column=2, value=ns_diff_val_list[i][1]).alignment = Alignment(wrapText=True)

                elif ns_diff_val_list[i][1] == res2[app][ns_diff_key].get(ns_diff_val_list[i][0]):
                    worksheet.cell(row=i + 2+row_num, column=3, value=ns_diff_val_list[i][1]).alignment = Alignment(wrapText=True)
    # 删除空行
    for row in range(worksheet.max_row):
        if worksheet.cell(row+1,column=1).value is None:
            worksheet.delete_rows(row+1)





dateObj = datetime.datetime.now()
dateStr = "%s-%s-%s_%s%s%s" % (dateObj.year, dateObj.month, dateObj.day, dateObj.hour, dateObj.month, dateObj.second)
compare_filename = './res/compare_app_apollo_res_%s.xlsx' % dateStr
# 删除空白的sheet
ws = workbook["Sheet"]
workbook.remove(ws)

workbook.save(compare_filename)

print('本次耗时：%s s' % (time.time() - s_time))
