# coding=utf-8
# __auther__ = 'lewen'
import xlwt
import datetime

import requests

# the init config
"""
username = 'apollo'
passwd = 'Qwer1234'

"""

url_live_core = 'https://apollo-core-id.bke.shopee.io'
url_dr_core = 'https://apollo-core-dr-id.bke.shopee.io'

url_live_app = 'https://apollo-id.bke.shopee.io/'
url_dr_app = 'https://apollo-dr-id.bke.shopee.io/'

api_token_live_core = 'ec23663826fac06be256e21bd5689da0c58578ed'
api_token_dr_core = '31d898a38e21cb348e7623a710febd2cd47480df'

api_token_live_app = '23efe9d8182000cacf1f570981902f9a0ebb664e'
api_token_dr_app = 'dd665fd387772cf289cdb50354da6ee09d71b7f8'

headers = {
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) '
                  'Chrome/72.0.3626.121 Safari/537.36',
    'Authorization': '',
    'Content-Type': 'application/json;charset=UTF-8'
}


def get_all_appid(url, token):
    url = url + '/openapi/v1/apps?appIds'

    print(url)
    headers["Authorization"] = token
    res_list = requests.get(headers=headers, url=url).json()

    # print(type(res_list),res_list)
    appid_list = []
    for item_dc in res_list:
        # print(item_dc)
        appid_list.append(item_dc["appId"])
    # print(appid_list)
    return appid_list


def get_all_props(url, token, appid, envs, clusters="default", namespaces="application"):
    url = url + f'/openapi/v1/envs/{envs}/apps/{appid}/clusters/{clusters}/namespaces/{namespaces}'
    headers["Authorization"] = token
    props = requests.get(headers=headers, url=url).json()
    # print(props)
    # return {
    #     "appId": props["appId"],
    #     "items": props["items"]
    # }

    # appId = props["appId"]
    app_props_dict = {}
    for single_props in props["items"]:
        if single_props["key"] == "":
            continue

        app_props_dict[single_props["key"]] = single_props["value"]
        # app_props_dict.append(s_dict)

    return app_props_dict


# 获取live的所有appid和配置


allApp = get_all_appid(url_live_app, api_token_live_app)
print(allApp)


def get_live_props():
    live_props = {}
    for app in allApp:
        app_props = get_all_props(url_live_app, api_token_live_app, app, envs="live")
        live_props[app] = app_props
    return live_props


def get_dr_props():
    dr_props = {}
    for app in allApp:
        app_props = get_all_props(url_dr_app, api_token_dr_app, app, envs="dr")
        dr_props[app] = app_props
    return dr_props


if __name__ == '__main__':
    import time

    s_time = time.time()
    res1 = get_live_props()
    res2 = get_dr_props()

print("res1", res1)
print("res2", res2)
# differ_dict = {}
workbook = xlwt.Workbook()
for app in allApp:
    # print('==开始比较===')
    # print(res1[app])
    differ_props = set(res1[app].items()) ^ set(res2[app].items())
    # print(differ_props)
    differ_props_list = list(differ_props)
    differ_props_list.sort()
    print(app, differ_props_list)
    # if differ_props:
    #     differ_dict[app] = list(differ_props)
    # print(differ_dict)

    worksheet = workbook.add_sheet(app)
    worksheet.write(0, 0, 'key')
    worksheet.write(0, 1, 'value_live')
    worksheet.write(0, 2, 'value_dr')
    for i in range(len(differ_props_list)):
        # print('differ_props_list[i][0]', differ_props_list[i][0])
        worksheet.write(i + 1, 0, differ_props_list[i][0])
        # print("differ_props_list[i][1]--》",differ_props_list[i][1],type(differ_props_list[i][1]))
        # print("res1[app][differ_props_list[i][0]]",res1[app][differ_props_list[i][0]],type(res1[app][
        # differ_props_list[i][0]]))
        if differ_props_list[i][1] == res1[app].get(differ_props_list[i][0]):
            worksheet.write(i + 1, 1, differ_props_list[i][1])
        elif differ_props_list[i][1] == res2[app].get(differ_props_list[i][0]):
            worksheet.write(i + 1, 2, differ_props_list[i][1])

dateObj = datetime.datetime.now()
dateStr = "%s-%s-%s_%s%s%s" % (dateObj.year, dateObj.month, dateObj.day, dateObj.hour, dateObj.month, dateObj.second)
compare_filename = 'compare_%s.xls' % dateStr

workbook.save(compare_filename)

print('本次耗时：%s s' % (time.time() - s_time))
