# coding=utf-8
# __auther__ = 'lewen'
import xlwt
import openpyxl
import datetime

import requests
from openpyxl.utils import get_column_letter
from openpyxl.styles import Alignment

# the init config
"""
username = 'apollo'
passwd = 'Qwer1234'

"""

urlLive = 'https://apollo-core-id.bke.shopee.io'

urlDr = 'https://apollo-core-dr-id.bke.shopee.io'

apiTokenLive = 'ec23663826fac06be256e21bd5689da0c58578ed'
# apiTokenLive = '834671ef3ac8b2a2dbd1230e9d62528c584175df'  # nonlive 的测试
apiTokenDr = '31d898a38e21cb348e7623a710febd2cd47480df'

headers = {
    'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) '
                  'Chrome/72.0.3626.121 Safari/537.36',
    'Authorization': '',
    'Content-Type': 'application/json;charset=UTF-8'
}


def get_all_appid(url, token):
    url = url + '/openapi/v1/apps?appIds'

    print(url)
    headers["Authorization"] = token
    res_list = requests.get(headers=headers, url=url).json()

    # print(type(res_list),res_list)
    appid_list = []
    for item_dc in res_list:
        # print(item_dc)
        appid_list.append(item_dc["appId"])
    # print(appid_list)
    return appid_list


def get_all_props(url, token, appid, envs, clusters="default"):
    url = url + f'/openapi/v1/envs/{envs}/apps/{appid}/clusters/{clusters}/namespaces'
    headers["Authorization"] = token
    props = requests.get(headers=headers, url=url).json()

    app_props_dict = {}
    # print(props)
    for ns_props in props:
        for single_props in ns_props["items"]:
            if single_props["key"] == "":
                continue

            app_props_dict[single_props["key"]] = single_props["value"]
        # app_props_dict.append(s_dict)

    return app_props_dict


# 获取live的所有appid和配置


allApp = get_all_appid(urlLive, apiTokenLive)
# allApp.remove('alarm-platform')
print(allApp)


def get_live_props():
    live_props = {}
    for app in allApp:
        app_props = get_all_props(urlLive, apiTokenLive, app, envs="live")
        live_props[app] = app_props
    return live_props


def get_dr_props():
    dr_props = {}

    for app in allApp:
        # print("dr app",app)
        app_props = get_all_props(urlDr, apiTokenDr, app, envs="dr")
        dr_props[app] = app_props
    return dr_props


if __name__ == '__main__':
    import time

    s_time = time.time()
    res1 = get_live_props()
    res2 = get_dr_props()

print("res1", res1)
print("res2", res2)
# differ_dict = {}
# workbook = xlwt.Workbook()
workbook = openpyxl.Workbook()

for app in allApp:
    # print('==开始比较===')
    # print(res1[app])
    differ_props = set(res1[app].items()) ^ set(res2[app].items())
    # print(differ_props)
    differ_props_list = list(differ_props)
    differ_props_list.sort()
    # print(app, differ_props_list)
    # if differ_props:
    #     differ_dict[app] = list(differ_props)
    # print(differ_dict)

    worksheet = workbook.create_sheet(app)

    worksheet.cell(row=1, column=1).value = 'key'
    worksheet.cell(row=1, column=2).value = 'value_live'  # write(0, 1, 'value_live')
    worksheet.cell(row=1, column=3).value = 'value_dr'  # write(0, 2, 'value_dr')

    worksheet.column_dimensions[get_column_letter(1)].width = 30
    worksheet.column_dimensions[get_column_letter(2)].width = 50
    worksheet.column_dimensions[get_column_letter(3)].width = 50

    for i in range(len(differ_props_list)):
        # print('differ_props_list[i][0]', differ_props_list[i][0])

        # if differ_props_list[i][0] == differ_props_list[i + 1][0]:
        #     worksheet.cell(row=i + 2, column=1).value = differ_props_list[i][0]
        #     if differ_props_list[i][1] == res1[app].get(differ_props_list[i][0]):
        #         worksheet.cell(row=i + 2, column=2).value = differ_props_list[i][1]
        #         # write(i + 1, 1, differ_props_list[i][1])
        #     elif differ_props_list[i][1] == res2[app].get(differ_props_list[i][0]):
        #         worksheet.cell(row=i + 2, column=3).value = differ_props_list[i][1]
        if differ_props_list[i][0] == differ_props_list[i - 1][0] and i > 0:
            # worksheet.cell(row=i + 1, column=1).value = differ_props_list[i][0]
            if differ_props_list[i][1] == res1[app].get(differ_props_list[i][0]):
                worksheet.cell(row=i + 1, column=2, value=differ_props_list[i][1]).alignment = Alignment(wrapText=True)
                # write(i + 1, 1, differ_props_list[i][1])
            elif differ_props_list[i][1] == res2[app].get(differ_props_list[i][0]):
                worksheet.cell(row=i + 1, column=3, value=differ_props_list[i][1]).alignment = Alignment(wrapText=True)
        else:
            worksheet.cell(row=i + 2, column=1, value=differ_props_list[i][0]).alignment = Alignment(wrapText=True)
            # write(i + 1, 0, differ_props_list[i][0])
            # print("differ_props_list[i][1]--》",differ_props_list[i][1],type(differ_props_list[i][1]))
            # print("res1[app][differ_props_list[i][0]]",res1[app][differ_props_list[i][0]],type(res1[app][
            # differ_props_list[i][0]]))
            if differ_props_list[i][1] == res1[app].get(differ_props_list[i][0]):
                worksheet.cell(row=i + 2, column=2, value=differ_props_list[i][1]).alignment = Alignment(wrapText=True)
                # write(i + 1, 1, differ_props_list[i][1])
            elif differ_props_list[i][1] == res2[app].get(differ_props_list[i][0]):
                worksheet.cell(row=i + 2, column=3, value=differ_props_list[i][1]).alignment = Alignment(wrapText=True)
            # worksheet.write(i + 1, 2, differ_props_list[i][1])

dateObj = datetime.datetime.now()
dateStr = "%s-%s-%s_%s%s%s" % (dateObj.year, dateObj.month, dateObj.day, dateObj.hour, dateObj.month, dateObj.second)
compare_filename = 'compare_core_live_and_dr_v4_%s.xlsx' % dateStr

# 删除空白的sheet
ws = workbook["Sheet"]
workbook.remove(ws)

workbook.save(compare_filename)

print('本次耗时：%s s' % (time.time() - s_time))
