#!/usr/bin/python
import json
import datetime
import subprocess

ak_sk = {
    "ak_bke_mobile": "BP9ATFIFSU3PJF67J5LJ",
    "sk_bke_mobile": "Qjf0TxhaBSXa23fRAJy0wzqRSUdbUQ9mYouqKi5G",
    "ak_bke_core": "4CZXJW7T8CCS7GJ958PJ",
    "sk_bke_core": "ytDBeP4pptCCUXBIN3IKe93BT7bSDZFBl4Roi5Ix",
    "ak_bke_dwh": "JZSG0196V86LBPGMPG6C",
    "sk_bke_dwh": "OGYfynlMjYCKef3RV10YOnaZPErqYy2e78DutqKp",
    "ak_banking_toc": "OEYQA8XI83J2ASBGC51D",
    "sk_banking_toc": "JpJO8oYKyibR9JhWz8APpxXHKhFRIe3HMNmto9oA",
    "ak_bke_video": "N6MVUH4KXJLFVI2FEIM1",
    "sk_bke_video": "5nOy7mIAaEx5hLwNVQ5AHfrtB0Us0LbFm35jI7Za",
    "ak_bke_ds": "BVBI9FSNQQESRTA37CEL",
    "sk_bke_ds": "xsBpssr3JDzCfAgFr6c9lDvav7TAYsh0WNOvWkNp",
    "ak_bke_xlog": "5QV63AHYGZ05F52050AP",
    "sk_bke_xlog": "MJRByPc7hkLTYj6wjUvKR65YsbgpaONEsc5EpHuh",
    "ak_tracker": "RRA0H18ZG4WD4WL0TWM6",
    "sk_tracker": "aBzwPf7fAmxKSQGpjhloJKDO1aj3YXbq1E1M5WAL"
}


def build_police():
    date_obj = datetime.datetime.now()
    date_str = "%s-%s-%s_%s%s%s" % (
        date_obj.year, date_obj.month, date_obj.day, date_obj.hour, date_obj.month, date_obj.second)

    bucket = input("plz input the bucket name :").strip('')
    owner = input("plz input the bucket owner:").strip('')
    user = input("plz input the auth user:").strip('')
    num = input("plz choose the permission (1.read 2.write 3.all)").strip()
    ak_key = ak_sk.get('ak_' + owner)
    sk_key = ak_sk.get('sk_' + owner)

    def police_template(user, action, bucket):
        return {
            "Sid": user,
            "Effect": "Allow",
            "Principal": {"AWS": "arn:aws:iam:::user/" + user},
            "Action": action,
            "Resource": [
                "arn:aws:s3:::" + bucket + "/*",
                "arn:aws:s3:::" + bucket,
            ]
        }

    statements = []

    def auth_temp(auth_num):
        if auth_num == "1":
            statements.append(police_template(user, "s3:GetObject*", bucket))
            statements.append(police_template(user, "s3:ListBucket*", bucket))
        elif auth_num == "2":
            statements.append(police_template(user, "s3:DeleteObject*", bucket))
            statements.append(police_template(user, "s3:PutObject*", bucket))
        elif auth_num == "3":
            statements.append(police_template(user, "s3:*", bucket))
        else:
            print("auth error")
        return {"Version": date_str, "Statement": statements}

    police = auth_temp(num)

    police_save_filename = "%s_policy_%s.json" % (bucket, date_str)
    with open(police_save_filename, 'a+') as f:
        f.write(json.dumps(police))

        exec_str = 's3cmd --no-ssl --access_key=%s --secret_key=%s --host-bucket= ---host=127.0.0.1:7480 ' \
                   'setpolicy' \
                   ' %s ' \
                   's3://%s' % (ak_key, sk_key, police_save_filename, bucket)
        print(exec_str)
        print(exec_func(exec_str))


def create_bucket():
    create_bucket_name = input('plz input the create bucket name:').strip('')
    bucket_owner = input('plz input the owner of bucket:').strip('')
    if 'ak_' + bucket_owner not in ak_sk:
        print('the owner is error')
    ak = ak_sk.get('ak_' + bucket_owner)
    sk = ak_sk.get('sk_' + bucket_owner)

    exec_str = 's3cmd --no-ssl --access_key=%s --secret_key=%s --host-bucket= ' \
               '--host=127.0.0.1:7480 mb s3://%s' % (ak, sk, create_bucket_name)
    print(exec_str)
    print(exec_func(exec_str))


def distribute_action():
    action = input('plz input num(1.create bucket 2.permission auth): ').strip('')
    if action == '1':
        return create_bucket()
    elif action == '2':
        return build_police()
    else:
        print('error. plz input num')


def exec_func(exec_str):
    res = subprocess.Popen(exec_str, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    print(str(res.stdout.read(), encoding='utf-8'))


if __name__ == '__main__':
    distribute_action()
