#!/usr/bin/python3

import json
import datetime
import subprocess

# nonlive 环境account的ak和sk
ak_sk = {
    "ak_bke_mobile": "AA4SBB0XBOV04SZGFB3Y",
    "sk_bke_mobile": "Ydw5yZojMCFBphApSRbmdS90zckQCahvHYjNCzpo",
    "ak_bke_core": "OJ3E2V5JOTD7E4P1LFUT",
    "sk_bke_core": "mzUEHjyA0yWNjBPCO7SNXhgHhP5GJyHFn8S8hxrO",
    "ak_bke_dwh": "RQ9OFBNPLWP2L7AIW6V0",
    "sk_bke_dwh": "AYADmM1mhgIZrVY64iDu4eKREFSOwwiKqsrJO4fj",
    "ak_banking_toc": "H3F7BZ0A7TD04YGRWDAW",
    "sk_banking_toc": "UBdNoP6FKi1RJJlsnUEfa1wty2pgh8bzTTYtj0tJ",
    "ak_tracker": "9HJH0I2D87LTYO6M4OQB",
    "sk_tracker": "YRX0kkJrmB11lEZs1E8SivlRvgxQeilWYveBxxvh",
    "ak_bke_log": "9BWV7SPDG3DK54MRA41C",
    "sk_bke_log": "k4VqAHLZhXwxolKBlQA0SHiwXbPcMSUXd67xqsev",
}

dateObj = datetime.datetime.now()
dateStr = "%s-%s-%s_%s%s%s" % (dateObj.year, dateObj.month, dateObj.day, dateObj.hour, dateObj.month, dateObj.second)



bucket = input("请输入你要授权的bucket:").strip('').split(',')
owner = input("请输入你要授权的bucket的owner:").strip('')
user = input("请输入你要授权的user:").strip('')
num = input("请选择要授予的权限数字(1.read 2.write 3.all)").strip()
ak_key = ak_sk.get('ak_' + owner)
sk_key = ak_sk.get('sk_' + owner)


def police_template(user, action, bucket):
    return {
        "Sid": user,
        "Effect": "Allow",
        "Principal": {"AWS": "arn:aws:iam:::user/" + user},
        "Action": action,
        "Resource": [
            "arn:aws:s3:::" + bucket + "/*",
            "arn:aws:s3:::" + bucket,
        ]
    }


statements = []


def auth_temp(auth_num, bucket):
    if auth_num == "1":
        statements.append(police_template(user, "s3:GetObject*", bucket))
        statements.append(police_template(user, "s3:ListBucket*", bucket))
    elif auth_num == "2":
        statements.append(police_template(user, "s3:DeleteObject*", bucket))
        statements.append(police_template(user, "s3:PutObject*", bucket))
    elif auth_num == "3":
        statements.append(police_template(user, "s3:*", bucket))
    else:
        print("权限有误，请重新输入")
    return {"Version": dateStr, "Statement": statements}


police = auth_temp(num)

police_save_filename = "%s_policy_%s.json" % (bucket, dateStr)
with open(police_save_filename, 'a+') as f:
    f.write(json.dumps(police))

    exec_str = 's3cmd --no-ssl --access_key=%s --secret_key=%s --host-bucket= ---host=127.0.0.1:7480 ' \
               'setpolicy' \
               ' %s ' \
               's3://%s' % (ak_key, sk_key, police_save_filename, bucket)

    print(exec_str)
    res = subprocess.Popen(exec_str, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    print(str(res.stdout.read(), encoding='utf-8'))
