# -*- coding: utf-8 -*-
# !/usr/bin/env python3
# yule.wen 2021/5/12-12:04 下午

import os
import csv
import sys
import datetime

base_dir = '/etc/nginx/certs/'
certname_list = os.listdir(base_dir)
headers = ['host_ip', 'name_space', 'MD5 key', 'ssl_start_time', 'ssl_end_time', 'MD5 ssl.chain']

host_ip = sys.argv[1]
if not host_ip:
    print('plz input ip')

res_list = []
for certname in certname_list:
    certname_check_list = [host_ip, certname]
    for filename in sorted(os.listdir(base_dir + certname)):

        if filename == 'ssl.chain.crt':
            ssl_file_name = base_dir + certname + "/" + filename
            cmd_ssl = 'openssl x509 -in %s -noout -dates' % (ssl_file_name)
            res_ssl = os.popen(cmd_ssl).read()
            my_GMT_FORMAT = '%b %d %H:%M:%S %Y GMT'

            date_start_cst = datetime.datetime.strptime(res_ssl.split('\n')[0].split('=')[1], my_GMT_FORMAT) + \
                             datetime.timedelta(hours=8)
            date_end_cst = datetime.datetime.strptime(res_ssl.split('\n')[1].split('=')[1], my_GMT_FORMAT) + \
                           datetime.timedelta(hours=8)

            certname_check_list.append(date_start_cst)
            certname_check_list.append(date_end_cst)

            file_obs_name = base_dir + certname + "/" + filename
            cmd_md5 = 'md5sum ' + file_obs_name
            res_md5 = os.popen(cmd_md5).read().split(' ')[0]
            certname_check_list.append(res_md5)

        elif filename == 'server.key':
            file_obs_name = base_dir + certname + "/" + filename
            cmd_md5 = 'md5sum ' + file_obs_name
            res_md5 = os.popen(cmd_md5).read().split(' ')[0]
            certname_check_list.append(res_md5)
        elif filename == 'backup':continue #判断如果是目录就需要跳过


    res_list.append(certname_check_list)

with open('cert-check.csv', 'w')as f:
    f_csv = csv.writer(f)
    f_csv.writerow(headers)
    f_csv.writerows(res_list)

