#!/usr/bin/python

from sys import argv
import json


def police_template(user, action, bucket):
    return {
        "Sid": user + '.' + action,
        "Effect": "Allow",
        "Principal": {"AWS": "arn:aws:iam:::user/" + user},
        "Action": action,
        "Resource": [
            "arn:aws:s3:::" + bucket + "/*",
            "arn:aws:s3:::" + bucket,
        ]
    }


script, bucket, all_users, read_users, put_users = argv
arr_all = all_users.split(' ')
arr_read = read_users.split(' ')
arr_put = put_users.split(' ')

statements = []
for user in arr_all:
    if user != "":
        statements.append(police_template(user, "s3:*", bucket))

for user in arr_read:
    if user != "":
        statements.append(police_template(user, "s3:GetObject*", bucket))
        statements.append(police_template(user, "s3:ListBucket*", bucket))

for user in arr_put:
    if user != "":
        statements.append(police_template(user, "s3:DeleteObject*", bucket))
        statements.append(police_template(user, "s3:PutObject*", bucket))

police = {"Version": "2012-10-17", "Statement": statements}
with open('./%s_police.json' % bucket, 'w', encoding='utf-8') as f:
    f.write(json.dumps(police))
