# -*- coding: utf-8 -*-
# !/usr/bin/env python3
# yule.wen 2021/6/24-10:22 上午
# use func: kafka create and search

# create
# kafka-topics.sh --list  --zookeeper 10.162.36.5:2181,10.162.36.6:2181,10.162.36.25:2181
# search
# kafka-topics.sh --create --zookeeper 10.162.36.5:2181,10.162.36.6:2181,10.162.36.25:2181 --replication-factor 3
# --partitions 6 --topic kyc-result-topic-ph-sit1


# kafka-topics.sh --list --zookeeper 10.162.36.5:2181,10.162.36.6:2181,10.162.36.25:2181

import os
import subprocess
import sys

help_str = """
Usage:
python3 kafka-crud.py ACTION [filename or topics]
or
kafka-crud ACTION [filename or topics]

Actions:

-f create from file, filename_path
-l search the topics
-c create single topics
"""


def print_green(s):
    print('\033[0;32;40m %s \033[0m' % s)


def print_red(s):
    print('\033[0;31;40m %s \033[0m' % s)


# get args
args_list = sys.argv
args_lens = len(args_list)
action = ''
name = ''
# zk cluster
zk_cluster = "10.163.52.120:2181,10.163.52.121:2181,10.163.52.122:2181/ibanking_uat_ph"

if args_lens != 3:
    print_red("plz input correct!")
    print_green(help_str)
    exit(1)
else:
    action = args_list[1]
    name = args_list[2]

if action == '-f':
    with open('./%s' % name, 'r', encoding='utf-8') as f:
        topic_list = f.readlines()
        # print(topic_list)
        cmd_create_list = []
        for topic in topic_list:
            if not topic:
                continue
            topic = topic.split('\n')[0]
            cmd_create_single = '/opt/kafka_setup/kafka_ibanking_uat2_ph/kafka_2.12-2.1.1/bin/kafka-topics.sh ' \
                                '--create --zookeeper %s --replication-factor 2 --partitions 6 ' \
                                '--topic %s' \
                                % (zk_cluster, topic)
            print(cmd_create_single)
            cmd_create_list.append(cmd_create_single)
        for cmd in cmd_create_list:
            res = os.popen(cmd)
            print(res.read())

elif action == '-l':
    cmd_check_single = '/opt/kafka_setup/kafka_ibanking_uat2_ph/kafka_2.12-2.1.1/bin/kafka-topics.sh --list ' \
                       '--zookeeper %s |grep %s' % (zk_cluster, name)

    res = os.popen(cmd_check_single)
    if not res.read():
        print_red('\nthe search topics not exist')
    else:
        print_green('it has existed')
    print(res.read())

elif action == '-c':
    cmd_create_single = '/opt/kafka_setup/kafka_ibanking_uat2_ph/kafka_2.12-2.1.1/bin/kafka-topics.sh --create ' \
                        '--zookeeper %s --replication-factor 2 --partitions 6 --topic %s' \
                        % (zk_cluster, name)

    res = os.popen(cmd_create_single)
    print(res.read())
elif action == '-d':

    cmd_delete_single = '/opt/kafka_setup/kafka_ibanking_uat2_ph/kafka_2.12-2.1.1/bin/kafka-topics.sh --delete ' \
                        '--zookeeper %s --replication-factor 2 --partitions 6 --topic %s' \
                        % (zk_cluster, name)

    res = os.popen(cmd_delete_single)
    print(res.read())



else:
    print_green(help_str)
