# -*- coding: utf-8 -*-
# !/usr/bin/env python3
# yule.wen 2021/8/26
import os
import json
from boto3.session import Session


def get_role_list():
    cmd_get_role_list = 'radosgw-admin user list'
    res_role_list = os.popen(cmd_get_role_list)
    role_list = json.load(res_role_list)
    # print(type(role_list))
    return role_list


def get_role_key(r_list):
    all_info = {}
    for role in r_list:
        cmd = 'radosgw-admin user info --uid=%s' % role
        role_key = json.load(os.popen(cmd)).get("keys")
        all_info[role] = role_key
    return all_info


# roles_list = get_role_list()
# all_role_key = get_role_key(roles_list)
# with open('./all_role_key.py', 'w', encoding='utf-8') as f:
#     f.write(json.dumps(all_role_key))


def get_bucket_policy(bucket, owner):
    roles_list = get_role_list()
    all_role_key = get_role_key(roles_list)
    access_key = all_role_key.get(owner)[0].get("access_key")
    secret_key = all_role_key.get(owner)[0].get("secret_key")
    url = "http://127.0.0.1:7480"

    session = Session(access_key, secret_key)
    s3_client = session.client('s3', endpoint_url=url)

    result = s3_client.get_bucket_policy(Bucket=bucket)

    policy = result['Policy']
    if policy:
        return policy
    else:
        print("The bucket has no policy!\n New authorization matrix will be created！ ")
        return policy


def police_template(user, action, bucket):
    return {
        "Sid": user + '.' + action,
        "Effect": "Allow",
        "Principal": {"AWS": "arn:aws:iam:::user/" + user},
        "Action": action,
        "Resource": [
            "arn:aws:s3:::" + bucket + "/*",
            "arn:aws:s3:::" + bucket,
        ]
    }
def auth_policy():


def gen_temp(bucket,auth_type,auth_user):
    statements = []
    if auth_policy == "read":
        statements.append(police_template(user, "s3:GetObject*", bucket))
        statements.append(police_template(user, "s3:ListBucket*", bucket))
    elif auth_policy == "write":
        statements.append(police_template(user, "s3:DeleteObject*", bucket))
        statements.append(police_template(user, "s3:PutObject*", bucket))
    elif auth_policy == "all":
        statements.append(police_template(user, "s3:*", bucket))
    else:
        print_red("auth error")
        exit(1)
    return {"Version": "2012-10-17", "Statement": statements}







