# -*- coding: utf-8 -*-
# !/usr/bin/env python3
# yule.wen 2021/8/11
# -*- coding: utf-8 -*-
# !/usr/bin/env python3
# yule.wen 2021/7/8-3:04
# use func:


import json
import datetime
import sys
import os
import subprocess

help_str = """
-c create single bucket
-o the bucket owner,this arg is must need
-f create bucket from file
-b build auth policy
-u user, auth the bucket to the user
-p policy eg: read/write/all

1.create single bucket
python3 ceph-create.py -c bucket_name -o bke_log

2.create bucket from bucket_file
python3 ceph-create.py -f bucket_file_name -o bke_log

3.auth bucket to user
python3 ceph-create.py -b bucket_name -o bke_log -u bke_core -p [read|write|all]


"""

ak_sk = {
    "bank_mobile": {
        "access_key": "AO3KK26A7QD617475W0V",
        "secret_key": "6tyx6F8kBJ7BX31x0wYysoXisOAj9Y83vA5Tt0FO"
    },
    "bank_core": {
        "access_key": "WW2Z27HWVXDY6VAUA7PE",
        "secret_key": "NMloUioPACx1BwqqQaS9w0ki13AOEmfesFOqTc5g"
    },
    "bank_dwh": {
        "access_key": "4DDHOJC4G32OKR6LB8EX",
        "secret_key": "or5O6ReKvvOCck07UkxDckCXO8qsXHPryMvhn2zU"
    },
    "bank_toc": {
        "access_key": "4N0RFJ96YP8G26T27ZMB",
        "secret_key": "LSwFR3DsYC5ZnrhXdhdIDdjfDTPwZCS7NepdqFHm"
    },
    "bank_video": {
        "access_key": "5442SM72MTN7JKY7M7YA",
        "secret_key": "LXnjjjH8CLtWURcLdqzD0Hd4zsydk73ktZUBsrHv"
    },
    "bank_ds": {
        "access_key": "SZXCORGHO060ZXWIUV3I",
        "secret_key": "shV1orUjmBhAbmbgFciVOtNNC0NHqPdAOJDy7HT7"
    },
    "bank_xlog": {
        "access_key": "366CUB304VDC4ZC72EZN",
        "secret_key": "Bnm5XrjhViR7YF4CEY1Y61IAonbuBXCZl6JG54Dk"
    },
    "bank_tracker": {
        "access_key": "7RQNT71VAPRMJHSUDEXR",
        "secret_key": "15d21Irhsj1RGYU4299b1F589yiRDnkC5Z68FkW7"
    },
    "bank_loan": {
        "access_key": "090N82U75MK8GUK0EUW1",
        "secret_key": "hjhG6UnJq1lzdZJKJTFlqAIxF5qvFz0sXC7MdTkr"
    },
    "bank_hris": {
        "access_key": "J5VP7YIT4V95MQE9POX0",
        "secret_key": "uuwsVL0OJgtlcGyg9szg4yO0DdDD9vgWV71mwlDa"
    }

}


def print_green(s):
    print('\033[0;32;40m %s \033[0m' % s)


def print_red(s):
    print('\033[0;31;40m %s \033[0m' % s)


def exec_func(exec_str):
    res = subprocess.Popen(exec_str, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    print(str(res.stdout.read(), encoding='utf-8'))


def build_police(bucket, owner, user, policy):
    date_obj = datetime.datetime.now()
    date_str = "%s-%s-%s_%s%s%s" % (
        date_obj.year, date_obj.month, date_obj.day, date_obj.hour, date_obj.month, date_obj.second)

    bucket = bucket.strip('')
    owner = owner.strip('')
    user = user.strip('')
    policy = policy.strip()
    if owner not in ak_sk:
        print_red('the owner is error')
        exit(1)
    ak_key = ak_sk.get(owner).get("access_key")
    sk_key = ak_sk.get(owner).get("secret_key")

    def police_template(auth_user, auth_action, auth_bucket):
        return {
            "Sid": auth_user,
            "Effect": "Allow",
            "Principal": {"AWS": "arn:aws:iam:::user/" + auth_user},
            "Action": auth_action,
            "Resource": [
                "arn:aws:s3:::" + auth_bucket + "/*",
                "arn:aws:s3:::" + auth_bucket,
            ]
        }

    statements = []

    def auth_temp(auth_policy):
        if auth_policy == "read":
            statements.append(police_template(user, "S3:GetObject*", bucket))
            statements.append(police_template(user, "S3:ListBucket*", bucket))
        elif auth_policy == "write":
            statements.append(police_template(user, "S3:DeleteObject*", bucket))
            statements.append(police_template(user, "S3:PutObject*", bucket))
        elif auth_policy == "all":
            statements.append(police_template(user, "S3:*", bucket))
        else:
            print_red("auth error")
            exit(1)
        return {"Version": date_str, "Statement": statements}

    police = auth_temp(policy)
    from pathlib import Path
    dir = Path('./policy_record')
    if not dir.exists():
        os.mkdir('policy_record')
    police_save_filename = "./policy_record/%s_policy_%s.json" % (bucket, date_str)
    with open(police_save_filename, 'a+') as f:
        f.write(json.dumps(police))

        exec_str = 's3cmd --no-ssl --access_key=%s --secret_key=%s --host-bucket= ---host=127.0.0.1:7480 ' \
                   'setpolicy' \
                   ' %s ' \
                   's3://%s' % (ak_key, sk_key, police_save_filename, bucket)
        print(exec_str)
        print(exec_func(exec_str))


def create_bucket(create_bucket_name, bucket_owner):
    create_bucket_name = create_bucket_name.strip('')
    bucket_owner = bucket_owner.strip('')
    if bucket_owner not in ak_sk:
        print_red('the owner is error')
        exit(1)
    ak = ak_sk.get(bucket_owner).get("access_key")
    sk = ak_sk.get(bucket_owner).get("secret_key")

    exec_str = 's3cmd --no-ssl --access_key=%s --secret_key=%s --host-bucket= ' \
               '--host=127.0.0.1:7480 mb s3://%s' % (ak, sk, create_bucket_name)
    print(exec_str)
    print(exec_func(exec_str))


args_list = sys.argv
args_lens = len(args_list)

action = ''
name = ''
# print(args_list, args_lens)


if args_lens == 5 or args_lens == 9:
    action = args_list[1]
    if action == '-c':
        bucket_name = args_list[2]
        owner = args_list[4]
        create_bucket(bucket_name, owner)
    elif action == '-f':
        bucket_file_name = args_list[2]
        owner = args_list[4]
        print(bucket_file_name, owner)
        with open('./%s' % bucket_file_name, 'r') as f:
            bucket_name_list = f.readlines()
        for i in bucket_name_list:
            create_bucket(i, owner)

    elif action == '-b':
        bucket_name = args_list[2]
        owner = args_list[4]
        user = args_list[6]
        policy = args_list[8]
        build_police(bucket_name, owner, user, policy)
    else:
        print_red('plz input correct')
        print_green(help_str)
else:
    print_red("plz input correct!")
    print_green(help_str)
    exit(1)
