import requests
import json
import os
import sys
import hashlib


def send_seatalk(webhook, description, proxies):
    payload = json.dumps({
        "tag": "text",
        "text": {
            "content": description,
            "at_all": False
        }
   })

    headers = {
        'Content-Type': 'application/json'
    }

    response = requests.request("POST", webhook, headers=headers, data=payload, proxies=proxies)

    print(response.text)

def diff_nginx_conf(dirs):
    os.system("find %s -type f | xargs md5sum > ./Version_2" % (dirs))
    f1 = open('./Version_1', 'r')
    f2 = open('./Version_2', 'r')
    text1 = []
    text2 = []
    for line in f1.readlines():
        text1.append(line)
    for line in f2.readlines():
        text2.append(line)

    tmp = set(text1) - set(text2)
    return tmp

def main():
    dirs = "/etc/nginx/"
   # webhook = "https://openapi.seatalk.io/webhook/group/esTHxT59RLCr-s7P0bwHYA"
   # webhook = "https://openapi.seatalk.io/webhook/group/9B7jMmOYSX-6TFdcOZBxaQ"
    webhook = "https://openapi.seatalk.io/webhook/group/9ruCgO0URJ6p70AuE7vmcA"
    env = "PH Live"
    cluster = "Nginx Core Slave 10.163.94.2"
    description = ''

    proxies = {
        "http"  : "http://10.163.69.206:3128",
        "https" : "https://10.163.69.206:3128",
    }

    if diff_nginx_conf(dirs):
        for i in diff_nginx_conf(dirs):
            description = description + "\n" + i.replace("\n","").split(' ',1)[1]
        description = "Env: " + env + "\n" + "Cluster: " + cluster + "\n" + "Description: Under nginx conf changed, please check." + description
        print(description)
        send_seatalk(webhook, description,proxies=proxies)
    os.system("mv ./Version_2 ./Version_1")


main()