#!/bin/python3

import os
import time
from pathlib import Path

old_rules_list = [
    '-ph.test.',
    '-ph.test-stable.',
    '-ph.uat.',
    '-ph.staging.',
    ]

new_rules_list = [
    '.test.ph.',
    '.test-stable.ph.',
    '.uat.ph.',
    '.staging.ph.'
]

start_time  = time.time()
old_domain_list = os.listdir('./')

# 备份目录
domain_bak_dir = Path('./old_domain_bak')
if not domain_bak_dir.exists():
    os.mkdir('./old_domain_bak')

def exec_str(cmd_str):
    res = os.popen(cmd_str).read()
    time.sleep(0.1) 
    return res

for domain in old_domain_list:
    if domain.endswith('.conf'):
        for old_rule in old_rules_list: # 轮询旧的规则
            if old_rule in domain: # 命中旧域名，下面开始更改
                print('find old domain rule',domain,old_rule)
                
                old_rule_index = old_rules_list.index(old_rule)
                print(old_rule_index)
                new_rule = new_rules_list[old_rule_index]
                print('new_rule',new_rule)
                # new_domain = re.sub(old_rule,new_rule,domain)
                
                
                # 创建新域名
                new_domain = domain.replace(old_rule,new_rule) #新域名
                cmd_cp_str = 'cp %s %s' %(domain,new_domain)
                print('create new rule domain',cmd_cp_str)
                exec_str(cmd_cp_str)                
                old_domain_str = domain.split('.conf')[0]
                new_domain_str = new_domain.split('.conf')[0]
                
                # 域名name 替换
                cmd_sed_str = "sed -i 's#%s#%s#g' %s" %(old_domain_str,new_domain_str,new_domain)
                print('start to sed str',cmd_sed_str)
                exec_str(cmd_sed_str)

                
                # 新域名证书替换
                old_ca_str = old_rule.replace('-ph','star')
                new_ca_str = 'star' + new_rule
                cmd_sed_ca_str = "sed -i 's#%s#%s#g' %s" %(old_ca_str,new_ca_str,new_domain)
                exec_str(cmd_sed_ca_str)

                
                # 备份域名
                cmd_bak_str = 'mv %s %s/' %(domain,domain_bak_dir)
                exec_str(cmd_bak_str)

                
    else:
        print(' this is not domain file: %s' %domain)
end_time = time.time()

print('domain rebanding done, cost %s s',end_time-start_time)     