
# ph 安装Nginx 的步骤
# 配置ph 代理


export http_proxy=http://10.163.69.206:3128;
export https_proxy=http://10.163.69.206:3128;

# nginx 安装
apt-get update -y
apt-get install libpcre3 libpcre3-dev openssl zlib1g-dev libssl-dev gcc make -y
apt-get install nginx -y


mkdir tools
cd tools

git clone -b v0.1.18 https://github.com/vozlt/nginx-module-vts 

wget https://github.com/hnlq715/nginx-vts-exporter/releases/download/v0.10.3/nginx-vts-exporter-0.10.3.linux-amd64.tar.gz
tar -zxvf nginx-vts-exporter-0.10.3.linux-amd64.tar.gz
mv nginx-vts-exporter-0.10.3.linux-amd64/nginx-vts-exporter /usr/local/bin/nginx-vts-exporter


#### SG
wget http://nginx.org/download/nginx-1.20.2.tar.gz  
tar zxvf nginx-1.20.2.tar.gz  
cd nginx-1.20.2  
./configure --with-compat --add-dynamic-module=../nginx-module-vts  && make modules 





mv objs/ngx_http_vhost_traffic_status_module.so /usr/share/nginx/modules 


echo "load_module modules/ngx_http_vhost_traffic_status_module.so;" > /usr/share/nginx/modules-available/module-vts.conf 

ln -s /usr/share/nginx/modules-available/module-vts.conf /etc/nginx/modules-enabled/module-vts.conf


### 配置nginx ， 在/etc/nginx/conf.d/下新增如下配置 stats.conf

cat >/etc/nginx/conf.d/stats.conf <<EOF
server {
   server_name 127.0.0.1;
   location /status {
       allow 127.0.0.1;
       deny all;
       vhost_traffic_status_display;
       vhost_traffic_status_display_format json;
   }
}
EOF

# 安装aws验证
cd ~/tools 
git clone https://github.com/anomalizer/ngx_aws_auth.git -b AuthV2   
cd nginx-1.20.2  
./configure --with-compat --add-dynamic-module=../ngx_aws_auth && make modules  
cp objs/ngx_http_aws_auth_module.so /usr/share/nginx/modules/  
tee /usr/share/nginx/modules-available/mod-http_aws_auth.conf  <<< "load_module modules/ngx_http_aws_auth_module.so;"  
ln -s /usr/share/nginx/modules-available/mod-http_aws_auth.conf /etc/nginx/modules-enabled/50-mod-http_aws_auth.conf   
cp /etc/nginx/nginx.conf{,.bak}












# 安装 keepalived
apt-get install keepalived -y







cat >/etc/keepalived/keepalived.conf << EOF
#master node
vrrp_script chk_nginx {
  script "killall -0 nginx"  # check the haproxy process
  interval 2 # every 2 seconds
  weight 2 # add 2 points if OK
}
vrrp_instance VI_1 {
  interface ens160 # 绑定的网卡要正确
  state MASTER
  virtual_router_id 52 #each group keepalived has one vlan id
  priority 101 #gt slave priority
  virtual_ipaddress {
    10.163.74.200 # 虚拟的IP要正确
  }
  track_script {
    chk_nginx #check script
  }
}
EOF

cat >/etc/keepalived/keepalived.conf << EOF
#slave node
vrrp_script chk_nginx {
  script "killall -0 nginx"  # check the nginx process
  interval 2 # every 2 seconds
  weight 2 # add 2 points if OK
}
vrrp_instance VI_1 {
  interface ens160   # 绑定的网卡要正确
  state BACKUP
  virtual_router_id 52
  priority 100
  virtual_ipaddress {
    10.163.74.200  # 虚拟的IP要正确
  }
  track_script {
    chk_nginx
  }
}
EOF


systemctl enable keepalived 
systemctl restart keepalived 
systemctl status keepalived 