mkdir ~/data
mkdir -p ~/data/mysql
mkdir -p ~/data/mysql/conf/
mkdir -p ~/data/mysql/logs/
mkdir -p ~/data/mysql/data/


[mysqld]
user=mysql
character-set-server=utf8
default_authentication_plugin=mysql_native_password
secure_file_priv=/var/lib/mysql
expire_logs_days=7
sql_mode=STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION
max_connections=1000

[client]
default-character-set=utf8

[mysql]
default-character-set=utf8



docker run --restart=always --privileged=true  \
-v ~/data/mysql/data/:/var/lib/mysql \
-v ~/data/mysql/logs/:/var/log/mysql \
-v ~/data/mysql/conf/:/etc/mysql \
-v ~/data/mysql/my.cnf:/etc/mysql/my.cnf  \
-p 3306:3306 --name my-mysql \
-e MYSQL_ROOT_PASSWORD=12345678 -d mysql:5.7
