



```
#Apollo配置中心portal-gateway微服务，集群：ph，名字空间：application
spring.cloud.zookeeper.discovery.root = /admin-portal-live-ph
spring.cloud.zookeeper.connect-string = corebank-zk-1.mdw.seabanksvc.com:4181,corebank-zk-2.mdw.seabanksvc.com:4181,corebank-zk-3.mdw.seabanksvc.com:4181
#hystrix.command.default.execution.isolation.thread.timeoutInMilliseconds = 60000
zuul.ribbon.eager-load.enabled = true
ribbon.ReadTimeout = 60000
ribbon.SocketTimeout = 60000
zuul.host.socket-timeout-millis = 60000
zuul.host.connect-timeout-millis = 60000
#允许头部字段透传
zuul.sensitive-headers = 
#payment路由转发
zuul.routes.payment-router.path = /api/gateway/**
zuul.routes.payment-router.url = http://pmt-portal-gateway-int.biz.seabanksvc.com:15000/gateway
zuul.routes.payment-router.strip-prefix = true
#redis配置信息
spring.redis.password = YniQ0AfonFP5
spring.redis.port = 8100
spring.redis.host = corebank-codis.mdw.seabanksvc.com
#后台接口白名单
auth.common.accessRight = /api/auth/flow/v1/viewAuthFlowByBusinessId,/api/auth/flow/v1/viewAuthFlowCommon,/api/auth/flow/v1/checkAuthFlowExist,/api/user-role/permission/v1/getList,/api/session/session/v1/userInfo,/api/session/session/v1/expire,/api/session/credential/v1/logout,/api/user-role/user/v1/getConfigList,/api/session/credential/v1/google/callback,/api/session/credential/v1/google/auth,/api/auth/flow/v1/preSubmitCheck,/api/auth/flow/v1/submitRequest,/api/user-role/limitConfig/v1/properties,/api/config-file/config/v1/getByEnumName,/api/config-file/config/v1/getAll,/api/config-file/config/v1/getByEnumNameBatch,/api/auth/flow/v1/isExist,/rpc/core-bank,/rpc/newom,/api/audit-service/v1/recordLog,/api/core-bank/MbsdCore_1400_9126,/api/core-bank/MbsdCore_1400_8000,/api/config-file/v1/ceph/file,/api/config-file/v1/ceph/uploadFile,/api/config-file/file/v1/download,/api/user-role/user/v1/getUserPositionList,/api/user-role/position/v1/getCheckerList,/api/auth/flow/v1/getCheckerList,/api/user-role/team/v1/teamPositionTree,/api/config-file/config/v1/getEnumByField,/api/config-file/config/v1/getPortalAll,/api/config-file/config/v1/getMarketConf
audit.log.operate = /api/auth/flow/v1/submitRequest,/api/auth/flow/v1/doAudit,/api/auth/flow/v1/cancelAudit
audit.log.loginOut = /api/session/credential/v1/google/callback,/api/session/credential/v1/logout,/api/session/credential/v1/login
#session配置
session.timeout.secs = 600
session.token.signKey = AABBCC
session.token.timeout = 1
zuul.routes.esb-core-bank.url = http://smartesb-int.biz.seabanksvc.com:20004/corebank
auth.permission.ignore = /api/session/credential/v1/google/callback,/api/session/credential/v1/google/auth,/rpc/core-bank,/rpc/newom,/api/session/session/v1/queryLoginMethods,/api/session/credential/v1/login
app.esb.tran-date.auto-fill.enabled = true
spring.servlet.multipart.enabled = true
spring.servlet.multipart.max-file-size = 20MB
spring.servlet.multipart.max-request-size = 50MB
zuul.routes.route-to-om.url = http://smartesb-int.biz.seabanksvc.com:21000/newom
zuul.routes.route-to-dwh.url = http://estatement-int.biz.seabanksvc.com:15000/estatement
app.zuul.third-route = esb-core-bank,route-to-auth
third-app.api-prefix = /third,/rpc
zuul.routes.esb-mobile-bank.url = http://smartesb-int.biz.seabanksvc.com:20006/gateway
# v0.5
zuul.routes.mobile-bank-file.url = http://file-gateway-ext.biz.seabanksvc.com
auth.header.ignore = /api/config-file/v1/ceph/file,/api/report/v1/sdic/download/file_download,/api/reporting/v1/task/download_file,/api/reporting/v1/task/download_url_file
# report服务转发
zuul.routes.route-to-report.path = /api/report/**
zuul.routes.route-to-report.serviceId = reporting-module-be
zuul.routes.route-to-report.strip-prefix = true
# uploadtool
zuul.routes.route-to-reporting-module-be.path = /api/reporting/**
zuul.routes.route-to-reporting-module-be.serviceId = reporting-module-be
zuul.routes.route-to-reporting-module-be.strip-prefix = true
# metadata服务转发
zuul.routes.route-to-metaData-be.path = /api/metaData/**
zuul.routes.route-to-metaData-be.serviceId = warehouse-metadata-sys
zuul.routes.route-to-metaData-be.strip-prefix = false
#rocketMQ配置
rocketmq.name-server = corebank-rocketmq-1.mdw.seabanksvc.com:9876;corebank-rocketmq-2.mdw.seabanksvc.com:9876
rocketmq.producer.group = audit-log-record
rocketmq.topic = banking-portal-audit-service
# kyc服务转发
zuul.routes.route-to-kyc.url = http://kyc-ext.biz.seabanksvc.com/
zuul.routes.route-to-kyc.path = /api/mobile-kyc/admin-kyc/**
zuul.routes.route-to-kyc2.url = http://kyc-ext.biz.seabanksvc.com/
zuul.routes.route-to-kyc2.path = /rpc/mobile-kyc/admin-kyc/**

#acquiring路由转发
zuul.routes.acquiring-router.path = /api/acquiring/**
zuul.routes.acquiring-router.url = http://pmt-acquiring-portal-gateway-int.biz.seabanksvc.com:15000/acquiring
zuul.routes.acquiring-router.strip-prefix = true

#2.11 loan转发
zuul.routes.route-to-loan.path = /api/loan/**
zuul.routes.route-to-loan.url = http://loan-transaction-int.biz.seabanksvc.com:15000
zuul.routes.route-to-loan-rpc.path = /rpc/loan/**
zuul.routes.route-to-loan-rpc.url = http://loan-transaction-int.biz.seabanksvc.com:15000
#2.11 kyc-onboard转发
zuul.routes.route-to-mobile-kyc-onboard.path = /api/mobile-kyc-onboard/**
zuul.routes.route-to-mobile-kyc-onboard.url = http://kyc-onboard-int.biz.seabanksvc.com:15000
#2.12 用户信息转发
zuul.routes.open-userinfo-rpc-api.path = /rpc/user-role/user/v1/getUserInfo
zuul.routes.open-userinfo-rpc-api.serviceId = portal-user-role
zuul.routes.open-userinfo-rpc-api.strip-prefix = false
zuul.routes.route-to-om.path = /*/newom


```