#中间件
#coredns


### coredns 配置文件 etcd
以etcd 作为域名存储解析
```
root@ph-drt-p-69-1-live:/etc/coredns# cat coredns.conf
.:53 {
    bind 0.0.0.0
    auto grpc-api.ingress api.ingress airpay.db {
        directory /etc/coredns/zones
        reload 3000s
        upstream
    }
    etcd k8s.cluster test.seabank.io test-stable.seabank.io uat.ph.seabank.io uat.seabank.io staging.seabank.io mdw.seabanksvc.com db.seabanksvc.com biz.seabanksvc.com seabanksvc.com seabank.io {
       path /phdb
       endpoint http://10.163.69.1:2379 http://10.163.69.2:2379 http://10.163.69.3:2379
       upstream  8.8.8.8:53 8.8.4.4:53
       fallthrough
    }
    prometheus :9153
    errors
    log
    cache 3600
    loadbalance
    forward . 8.8.8.8:53 {
      except k8s.cluster
    }
}

```


### 以物理文件形式进行解析

#### coredns.conf
```
root@ph-drt-v-69-101-live:/etc/coredns# cat coredns.conf
seabank.io:53 {
    file /etc/coredns/zones/db.seabank.io
    reload 5s
    log
    loadbalance
}
ph.seabank.io:53 {
    file /etc/coredns/zones/db.ph.seabank.io
    reload 5s
    log
    loadbalance
}

uat.seabank.io:53 {
    file /etc/coredns/zones/db.uat.seabank.io
    reload 5s
    log
    loadbalance
}
uat.ph.seabank.io:53 {
    file /etc/coredns/zones/db.uat.ph.seabank.io
    reload 5s
    log
    loadbalance
}
test.seabank.io:53 {
    file /etc/coredns/zones/db.test.seabank.io
    reload 5s
    log
    loadbalance
}
test.ph.seabank.io:53 {
    file /etc/coredns/zones/db.test.ph.seabank.io
    reload 5s
    log
    loadbalance
}
test-stable.seabank.io:53 {
    file /etc/coredns/zones/db.test-stable.seabank.io
    reload 5s
    log
    loadbalance
}
test-stable.ph.seabank.io:53 {
    file /etc/coredns/zones/db.test-stable.ph.seabank.io
    reload 5s
    log
    loadbalance
}
staging.seabank.io:53 {
    file /etc/coredns/zones/db.staging.seabank.io
    reload 5s
    log
    loadbalance
}
staging.ph.seabank.io:53 {
    file /etc/coredns/zones/db.staging.ph.seabank.io
    reload 5s
    log
    loadbalance
}
.:53 {
    forward . 8.8.8.8:53
}
```


#### db.file
```
root@ph-drt-v-69-101-live:/etc/coredns/zones# cat db.seabank.io
$ORIGIN seabank.io.
@    3600 IN    SOA sns.dns.icann.org. noc.dns.icann.org. (
                20211111   ; serial
                7200       ; refresh (2 hours)
                3600       ; retry (1 hour)
                1209600    ; expire (2 weeks)
                3600       ; minimum (1 hour)
                )
    3600 IN NS a.iana-servers.net.
    3600 IN NS b.iana-servers.net.

corebank-k8s-ph   	IN	A	10.163.80.200
gitlab-sg         	IN	A	10.163.69.205
harbor-sg         	IN	A	192.168.165.32
hot-admin-ph      	IN	A	10.163.80.200
ibank-k8s-ph      	IN	A	10.163.80.200
log-admin-ph      	IN	A	10.163.80.200

test                                    IN A      10.163.80.200
root@ph-drt-v-69-101-live:/etc/coredns/zones# cat db.uat.seabank.io
$ORIGIN uat.seabank.io.
@    3600 IN    SOA sns.dns.icann.org. noc.dns.icann.org. (
                20211110   ; serial
                7200       ; refresh (2 hours)
                3600       ; retry (1 hour)
                1209600    ; expire (2 weeks)
                3600       ; minimum (1 hour)
                )

    3600 IN NS a.iana-servers.net.
    3600 IN NS b.iana-servers.net.

admin-uat1-ph                      	IN	A	10.163.55.200
airflow-uat1-ph                    	IN	A	10.163.55.200
ann-uat1-ph                        	IN	A	10.163.55.200
apollo-ph                          	IN	A	10.163.55.200
app-uat-k8s-ph                     	IN	A	10.163.55.200
arm-uat1-ph                        	IN	A	10.163.55.200
ceph-ph                            	IN	A	10.163.55.200
cm-uat1-ph                         	IN	A	10.163.55.200
core-uat-k8s-ph                    	IN	A	10.163.55.200
corebank-xxljob-uat1-ph            	IN	A	10.163.55.200
cs-canal-ph                        	IN	A	10.163.55.200
cs-config-center-ph                	IN	A	10.163.55.200

```


#### coredns.service
```
root@ph-drt-v-69-101-live:/etc/coredns/zones# systemctl status coredns.service
● coredns.service - Coredns
     Loaded: loaded (/lib/systemd/system/coredns.service; enabled; vendor preset: enabled)
     Active: active (running) since Fri 2022-02-11 10:08:39 +08; 1 weeks 0 days ago
   Main PID: 240317 (coredns)
      Tasks: 15
     Memory: 12.0M
     CGroup: /system.slice/coredns.service
             └─240317 /usr/local/bin/coredns -conf /etc/coredns/coredns.conf -pidfile /var/run/coredns.pid

2月 18 16:46:23 ph-drt-v-69-101-live coredns[240317]: [INFO] 10.163.9.148:42076 - 34598 "A IN toc.ph.seabank.io. udp 35 false 512" NOERROR qr,aa,rd 158>
2月 18 16:46:25 ph-drt-v-69-101-live coredns[240317]: [INFO] 10.163.9.92:63913 - 42131 "A IN wpad.seabank.io. udp 33 false 512" NXDOMAIN qr,aa,rd 113 0>
2月 18 16:46:27 ph-drt-v-69-101-live coredns[240317]: [INFO] 10.163.9.91:50277 - 55808 "A IN wpad.seabank.io. udp 33 false 512" NXDOMAIN qr,aa,rd 113 0>
2月 18 16:46:27 ph-drt-v-69-101-live coredns[240317]: [INFO] 10.163.9.91:58822 - 45107 "A IN wpad.seabank.io. udp 33 false 512" NXDOMAIN qr,aa,rd 113 0>
2月 18 16:46:27 ph-drt-v-69-101-live coredns[240317]: [INFO] 10.163.9.91:53541 - 56668 "A IN wpad.seabank.io. udp 33 false 512" NXDOMAIN qr,aa,rd 113 0>
2月 18 16:46:28 ph-drt-v-69-101-live coredns[240317]: [INFO] 10.163.9.91:62883 - 4426
```


#### systemd coredns.service
```
root@ph-drt-v-69-101-live:/etc/coredns/zones# cat /lib/systemd/system/coredns.service
[Unit]
Description=Coredns
After=network-online.target

[Service]
Type=simple
ExecStart=/usr/local/bin/coredns -conf /etc/coredns/coredns.conf -pidfile /var/run/coredns.pid
Restart=always
RestartSec=10
ExecStop=/bin/kill -9 $MAINPID
ExecReload=/bin/kill -HUP $MAINPID
StandardOutput=syslog
StandardError=syslog
SyslogIdentifier=coredns

[Install]
WantedBy=multi-user.target
```




#### logrotate
```
root@iddcipl00055:/etc/coredns# cat /etc/logrotate.d/coredns
/var/log/coredns/coredns.log {
    monthly
    rotate 5
    compress
    delaycompress
    missingok
    notifempty
    create 644 syslog adm
}
```