#中间件
#es

### system service
```
root@ph-drt-p-75-88-live:~# cat /lib/systemd/system/es-es-banking-digital-ph-new-live-node-01.service
[Unit]
Description=es-es-banking-digital-ph-new-live-node-01
Wants=network-online.target
After=network-online.target

[Service]
RuntimeDirectory=es-es-banking-digital-ph-new-live-node-01
PrivateTmp=true
EnvironmentFile=/etc/default/elasticsearch.es-es-banking-digital-ph-new-live-node-01
Environment=PID_DIR=/var/run/es-es-banking-digital-ph-new-live-node-01
WorkingDirectory=/opt/elasticsearch-7.14.2

User=elasticsearch
Group=elasticsearch

ExecStart=/opt/elasticsearch-7.14.2/bin/elasticsearch -p ${PID_DIR}/elasticsearch.pid
Restart=on-failure

StandardOutput=journal
StandardError=inherit

LimitNOFILE=400000
LimitNPROC=25000
LimitAS=infinity
LimitMEMLOCK=infinity
LimitFSIZE=infinity
LimitCORE=infinity

# Disable timeout logic and wait until process is stopped
TimeoutStopSec=0

# SIGTERM signal is used to stop the Java process
KillSignal=SIGTERM

# Send the signal only to the JVM rather than its control group
KillMode=process

# Java process is never killed
SendSIGKILL=no

# When a JVM receives a SIGTERM signal it exits with code 143
SuccessExitStatus=143

# resource limit



[Install]
WantedBy=multi-user.target
```



```
root@ph-drt-p-75-88-live:~# cat /etc/default/elasticsearch.es-es-banking-digital-ph-new-live-node-01
JAVA_HOME=/opt/jdk-12.0.2
ES_HOME=/opt/elasticsearch-7.14.2
ES_PATH_CONF=/etc/elasticsearch/nodes/es-banking-digital-ph-new-live-node-01

root@ph-drt-p-75-88-live:~# ls /opt/elasticsearch-7.14.2
bin  config  lib  LICENSE.txt  logs  modules  NOTICE.txt  plugins  README.asciidoc

```



```
root@ph-drt-p-75-88-live:/etc/elasticsearch/nodes/es-banking-digital-ph-new-live-node-01# cat elasticsearch.yml
cluster:
  name: 'es-banking-digital-ph-new-live'
  remote.connect: false
  initial_master_nodes: ["node-01", "node-02", "node-03"]

node.name: 'node-01'

node.master: true
node.data: true
node.ingest: true


xpack.ml.enabled: false

network.host: '10.163.75.88'
http.port: 9200
transport.port: 9300
discovery.seed_hosts: ["10.163.75.88:9300", "10.163.75.89:9300", "10.163.75.90:9300"]

bootstrap.memory_lock: true

cluster.routing.allocation.same_shard.host: true

path:
  data: '/data/elasticsearch/es-banking-digital-ph-new-live-node-01/data'
  logs: '/data/elasticsearch/es-banking-digital-ph-new-live-node-01/logs'
  repo: ['/data/elasticsearch/es-banking-digital-ph-new-live-node-01/backups']

indices.fielddata.cache.size: '10%'
cluster.max_shards_per_node: 2000
```




```
root@ph-drt-p-75-88-live:/etc/elasticsearch/nodes/es-banking-digital-ph-new-live-node-01# curl 10.163.75.88:9200/
{
  "name" : "node-01",
  "cluster_name" : "es-banking-digital-ph-new-live",
  "cluster_uuid" : "0_8rWhduQ9C_DCuvMmxJXw",
  "version" : {
    "number" : "7.14.2",
    "build_flavor" : "default",
    "build_type" : "tar",
    "build_hash" : "6bc13727ce758c0e943c3c21653b3da82f627f75",
    "build_date" : "2021-09-15T10:18:09.722761972Z",
    "build_snapshot" : false,
    "lucene_version" : "8.9.0",
    "minimum_wire_compatibility_version" : "6.8.0",
    "minimum_index_compatibility_version" : "6.0.0-beta1"
  },
  "tagline" : "You Know, for Search"
}
```