#中间件 
#etcd


#### systemd service
```

root@ph-drt-p-69-1-live:/etc/coredns# cat /lib/systemd/system/etcd-bank-coredns-live-ph.service
[Unit]
Description=etcd-bank-coredns-live-ph
Wants=network-online.target
After=network-online.target

[Service]
ExecStart=/usr/local/bin/etcd-v3.4.3 \
  --name=bank-coredns-live-ph-etcd-01 \
  --data-dir=/data/etcd/bank-coredns-live-ph-bank-coredns-live-ph-etcd-01 \
  --listen-peer-urls='http://10.163.69.1:2380' \
  --initial-advertise-peer-urls="http://10.163.69.1:2380" \
  --listen-client-urls='http://10.163.69.1:2379' \
  --advertise-client-urls="http://10.163.69.1:2379" \
  --initial-cluster="bank-coredns-live-ph-etcd-01=http://10.163.69.1:2380,bank-coredns-live-ph-etcd-02=http://10.163.69.2:2380,bank-coredns-live-ph-etcd-03=http://10.163.69.3:2380" \
  --initial-cluster-token='bank-coredns-live-ph' \
  --initial-cluster-state=new \
  --quota-backend-bytes=8589934592 \
  --enable-pprof \
  --metrics=extensive \
  --auto-compaction-mode=revision \
  --auto-compaction-retention=100000

User=etcd
Group=etcd

StandardOutput=journal
StandardError=inherit

PrivateTmp=true
RuntimeDirectory=etcd-bank-coredns-live-ph-bank-coredns-live-ph-etcd-01
WorkingDirectory=/opt/etcd-v3.4.3-linux-amd64


LimitNOFILE=65535
LimitNPROC=4096
LimitAS=infinity
LimitMEMLOCK=infinity
LimitFSIZE=infinity

Restart=always
RestartSec=5s

[Install]
WantedBy=multi-user.target
root@ph-drt-p-69-1-live:/etc/coredns# id etcd
uid=996(etcd) gid=996(etcd) groups=996(etcd)
root@ph-drt-p-69-1-live:/etc/coredns#

```



```
root@ph-drt-p-69-2-live:/data/etcd# tree bank-coredns-live-ph-bank-coredns-live-ph-etcd-02/member/
bank-coredns-live-ph-bank-coredns-live-ph-etcd-02/member/
├── snap
│   └── db
└── wal
    ├── 0000000000000000-0000000000000000.wal
    └── 0.tmp

2 directories, 3 files
```





### 获取key
```
root@ph-drt-p-69-2-live:/data/etcd# etcdctl-v3.4.3 --endpoints="http://10.163.69.2:2379" get /phdb/io/seabank/ph/zabbix
/phdb/io/seabank/ph/zabbix
{"host":"10.163.80.200","ttl":30}
```

```
获取所有
root@ph-drt-p-69-2-live:/data/etcd# etcdctl-v3.4.3 --endpoints="http://10.163.69.2:2379" get --prefix ""
```


```
设置值
etcdctl-bke-nonlive put /bkedns/io/seabank/id/uat/monitoring-nonlive '{"host":"10.162.32.17","ttl":30}'
```