








### nginx 配置 多个server_name
```

root@sg-drt-v-55-1-nonlive:/etc/nginx/conf.d# cat ceph-corebank-80-dev1.mdw.sg.seabanksvc.com.conf
server {
    listen              80;
    server_name         corebank-ceph-dev1.mdw.seabanksvc.com;
    server_name         corebank-ceph-dev2.mdw.seabanksvc.com;
    server_name         corebank-ceph-dev3.mdw.seabanksvc.com;
    server_name         corebank-ceph-sit1.mdw.seabanksvc.com;
    server_name         corebank-ceph-sit2.mdw.seabanksvc.com;
    server_name         corebank-ceph-staging.mdw.seabanksvc.com;

    client_max_body_size   0;
    access_log /var/log/nginx/corebank-ceph-dev2.mdw.seabanksvc.com.access.log;
    error_log /var/log/nginx/corebank-ceph-dev2.mdw.seabanksvc.com.error.log;
    location / {

	# https://jira.shopee.io/browse/SPTOS-27524
	add_header Access-Control-Allow-Origin *;
	add_header Access-Control-Allow-Methods 'GET, POST, OPTIONS';
	add_header Access-Control-Allow-Headers 'DNT,X-Mx-ReqToken,Keep-Alive,User-Agent,X-Requested-With,If-Modified-Since,Cache-Control,Content-Type,Authorization';
	if ($request_method = 'OPTIONS') {
        	return 204;
    	}

        proxy_pass_header Server;
        proxy_buffering    off;
        proxy_intercept_errors on;

        proxy_set_header Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        proxy_set_header   X-Real-IP          $remote_addr;
        proxy_http_version 1.1;
        proxy_set_header Connection "";
        proxy_pass http://ceph-core-nonlive;
    }
}


```