

改造后的xxl-job configmap 的格式有了变化



## xxl-job-admin configmap config



下面是configmap的内容，

需要将MySQL数据库的三行配置修改，其他的不用改动

这三行配置：

```yaml
  spring.datasource.password=asd!Qwe123

    spring.datasource.url=jdbc:mysql://10.165.62.66:6606/xxl_job_dev?useUnicode=true&characterEncoding=UTF-8

    spring.datasource.username=bank_test
```

完整的内容

新建的时候注意更改 cm的名称，namespace 

```yaml
---
apiVersion: v1
data:
  application.properties: >
    ### web

    server.port=8080

    server.context-path=/xxl-job-admin

    endpoints.prometheus.enabled=true


    ### actuator

    management.port = 16000

    management.context-path=/actuator

    management.security.enabled=false

    management.health.mail.enabled=false


    ### resources

    spring.mvc.servlet.load-on-startup=0

    spring.mvc.static-path-pattern=/static/**

    spring.resources.static-locations=classpath:/static/


    ### freemarker

    spring.freemarker.templateLoaderPath=classpath:/templates/

    spring.freemarker.suffix=.ftl

    spring.freemarker.charset=UTF-8

    spring.freemarker.request-context-attribute=request

    spring.freemarker.settings.number_format=0.##########


    ### mybatis

    mybatis.mapper-locations=classpath:/mybatis-mapper/*Mapper.xml


    ### xxl-job, datasource

    spring.datasource.password=asd!Qwe123

    spring.datasource.url=jdbc:mysql://10.165.62.66:6606/xxl_job_dev?useUnicode=true&characterEncoding=UTF-8

    spring.datasource.username=bank_test

    spring.datasource.driver-class-name=com.mysql.jdbc.Driver


    spring.datasource.type=org.apache.tomcat.jdbc.pool.DataSource

    spring.datasource.tomcat.max-wait=10000

    spring.datasource.tomcat.max-active=30

    spring.datasource.tomcat.test-on-borrow=true

    spring.datasource.tomcat.validation-query=SELECT 1

    spring.datasource.tomcat.validation-interval=30000

    spring.datasource.tomcat.jdbc-interceptors=org.apache.tomcat.jdbc.pool.interceptor.SlowQueryReport(logFailed=true,logSlow=true,threshold=100)


    ### xxl-job email

    spring.mail.host=smtp.qq.com

    spring.mail.port=25

    spring.mail.username=xxx@qq.com

    spring.mail.password=xxx

    spring.mail.properties.mail.smtp.auth=true

    spring.mail.properties.mail.smtp.starttls.enable=true

    spring.mail.properties.mail.smtp.starttls.required=true

    spring.mail.properties.mail.smtp.socketFactory.class=javax.net.ssl.SSLSocketFactory


    ### xxl-job, access token

    xxl.job.accessToken=


    ### xxl-job, i18n (default empty as chinese, "en" as english)

    xxl.job.i18n=


    ## xxl-job, triggerpool max size

    xxl.job.triggerpool.fast.max=200

    xxl.job.triggerpool.slow.max=100


    ### xxl-job, log retention days

    xxl.job.logretentiondays=30


    ### pool monitor

    xxl.job.trigger.pool.monitor.corn=0/4 * * * * ?

    xxl.job.db.pool.monitor.corn=0/5 * * * * ?
kind: ConfigMap
metadata:
  name: xxl-job-core-dev1-sg-new
  namespace: core-dev1-sg
```



## deployment 的配置

- 需要注意修改标签，镜像标签

- 需要新增的日志和configmap内容

其中的挂载配置

```yaml
        volumeMounts:
        - mountPath: /data/server/xxl-job/config/application.properties
          name: volume-xxl-cm
          subPath: application.properties
        - mountPath: /data/server/xxl-job/log
          name: xxl-job
      dnsPolicy: Default
      restartPolicy: Always
      schedulerName: default-scheduler
      terminationGracePeriodSeconds: 30
      volumes:
      - configMap:
          defaultMode: 420
          items:
          - key: application.properties
            path: application.properties
          name: xxl-job-core-dev1-sg-new
        name: volume-xxl-cm
      - hostPath:
          path: /data/log/xxl-job-core-dev1-sg-new
          type: DirectoryOrCreate
        name: xxl-job
```



完整的内容

```yaml
apiVersion: apps/v1
kind: Deployment
metadata:
  annotations:
    prometheus.io/scrape: "true"
  labels:
    app: xxl-job-core-dev1-sg-new
    app.kubernetes.io/managed-by: Helm
    application: xxl-job-admin-new
    cid: sg
    env: dev1
    group: Banking
    phase: release
    project: core
    name: xxl-job-core-dev1-sg-new
  namespace: core-dev1-sg
spec:
  replicas: 1
  selector:
    matchLabels:
      app: xxl-job-core-dev1-sg-new
  template:
    metadata:
      annotations:
        prometheus.io/scrape: "true"
      labels:
        app: xxl-job-core-dev1-sg-new
        app.kubernetes.io/managed-by: Helm
        application: xxl-job-admin-new
        cid: sg
        env: dev1
        group: Banking
        phase: release
        project: core
      name: xxl-job-core-dev1-sg-new
    spec:
      containers:
      - image: harbor.sg.maribank.io/seabank/xxl-job-admin:2.1.2-banking-sg
        imagePullPolicy: IfNotPresent
        name: xxl-job
        ports:
        - containerPort: 8080
          name: xxl-job-admin
          protocol: TCP
        resources:
          limits:
            cpu: "2"
            memory: 4Gi
          requests:
            cpu: 500m
            memory: 4Gi
        volumeMounts:
        - mountPath: /data/server/xxl-job/config/application.properties
          name: volume-xxl-cm
          subPath: application.properties
        - mountPath: /data/server/xxl-job/log
          name: xxl-job
      dnsPolicy: Default
      restartPolicy: Always
      schedulerName: default-scheduler
      terminationGracePeriodSeconds: 30
      volumes:
      - configMap:
          defaultMode: 420
          items:
          - key: application.properties
            path: application.properties
          name: xxl-job-core-dev1-sg-new
        name: volume-xxl-cm
      - hostPath:
          path: /data/log/xxl-job-core-dev1-sg-new
          type: DirectoryOrCreate
        name: xxl-job
```

